
%Zenei jelfeldolgozas - elso eloadas, demo 
%Copyright: Bank Balazs, BME MIT 2006-2020.

%elektromosgitar-hang analizise

echo on;

[rythm,Fs]=audioread('gitar_D_rythm.wav'); %a wav file betoltese
Fs%mintaveteli frekvencia kiiratasa
pause;

plot(rythm);%az idofuggvany kirajzoltatasa
pause;

WL=2^16; %alblakmeret
rythmw=rythm(1:WL).*hanning(WL); % szorzas hanning ablakfuggvenyyel
sp=fft(rythmw); %a spektrum szamitasa FFT-vel
frv=[0:WL-1]*Fs/WL; %frekvenciaertekek szamitasa 
plot(frv(1:WL/2),20*log10(abs(sp(1:WL/2)))); %csak a feleig rajzolunk, utana ugyis tukros

pause;

specgram(rythm,2^10,Fs);%spektrogram kiszamitasa - lathatoan 5 kHz feletti reszt felesleges vizsgalni
pause;

rythmres=resample(rythm,1,4,128); %ezert negyede akkora mintaveteli frekvenciara decimaljuk a jelet
Fsres=Fs/4
pause;

specgram(rythmres,2^10,Fsres); %es ujra megnezzuk a spectrogrammot
colorbar;
pause;

specgram(rythmres,2^12,Fsres); %lathato, hogy ha az ablakmeretet 2^12-re noveljuk, a frekv. felbontas no, de az idobeli romlik
colorbar;
pause;

specgram(rythmres,2^8,Fsres); %ha pedig 2^8-ra csokkentjuk, az idobeli felbontas javul
colorbar;
pause;

specgram(rythmres,2^10,Fsres); %a 2^10-es jo kompromisszumnak tunik
colorbar;
pause;

[B,F,T]=specgram(rythmres,2^10,Fsres); %ha ennek egy fuggoleges szeletet vizsgaljuk, megkapjuk a spektrumot egy idopontban
plot(F,db(B(:,1)));
pause;

plot(T,db(B(14,:))); %ha pedig vizszintes szeletet, akkor pedig az adott frek. sav burkoljat (itt ez az elso harmonikus))
pause;

echo off;
