%Zenei jelfeldolgozas - elso eloadas, demo 
%Copyright: Bank Balazs, BME MIT 2006-2020.

%egyszeru digitalis hullamvezeto, a hur vegein van reflexio (-1-szeres)


WGN=100; %a digitalis hullamvezeto (waveguide) hossza mintakban
Pick=20; %pengetesi pozicio

SampleNum=100;

UpperDL=zeros(1,WGN); %Felso kesleltetovonal (jobbra halado hullam)
LowerDL=zeros(1,WGN); %Also kesleltetovonal (balra halado hullam)

%%%%%%%%%%%%%%%%%%
%kezdeti ertek - impulzus
UpperDL(Pick)=1;
LowerDL(Pick)=1;



%%%%%%%%%%%%%%%%%%
%
for k=1:SampleNum,
   
   UpperDL=[0 UpperDL(1:WGN-1)]; %a kesleltetovonalak tartalmanak shiftelese
   LowerDL=[LowerDL(2:WGN) 0];
   
   Refl=-1; %visszaverodes a lezarasoknal
   UpperDL(1)=Refl*LowerDL(1);
   LowerDL(WGN)=Refl*UpperDL(WGN);

   
   Displ=UpperDL+LowerDL; %a ket haladohullam szuperpozicioja
   
   
   %rajzolas
   
   subplot(3,1,1);
   plot(UpperDL); %felso hullamvezeto
   axis([1 WGN -2 2]);
   subplot(3,1,2);
   plot(LowerDL); %also hullamvezeto
   axis([1 WGN -2 2]);
   subplot(3,1,3);
   plot(Displ,'r'); %kiteres
   axis([1 WGN -2 2]);
   
   pause(0.1);
%	F(1)=getframe;
end;


